	.NOLIST
MESSAGE	MOV R0,B	; Zaehler       B: MSG-Nummer
	MOV A,R0	; Message veraendert ?
	CJNE A,MESSGNR,MESSA
	RET

MESSA	MOV MESSGNR,B	; Nummer speichern
	PUSH DPH
	PUSH DPL
	MOV DPTR,#$C000	; Kommandoregister
	MOV A,#$A8	; 2.Zeile
	MOVX @DPTR,A
	LCALL VERZ
	MOV A,R0
	MOV R0,#$00
	MOV B,#$10
	MUL AB
	ADD  A,#$10
	MOV B,A
MESS1	MOVC A,@A+PC	; Zeichen holen
	LCALL WAITL
	INC B
	INC R0
	MOV A,B
	CJNE R0,#$10,MESS1
	POP DPL
	POP DPH
	RET
	.TEXT " INTERNAL ERROR " ;00
	.TEXT " MEMORY FULL !  " ;01
	.TEXT " PLOTTING...    " ;02
	.TEXT " WAITING...     " ;03
	.TEXT " TESTING RAM    " ;04
	.TEXT " READY.         " ;05
	.TEXT " END OF FILE    " ;06
	.TEXT " GO TO 0,0      " ;07
	.TEXT "                " ;08
	.TEXT " X- HURT !!     " ;09
	.TEXT " Y- HURT !!     " ;0A
	.TEXT " X+ HURT !!     " ;0B
	.TEXT " Y+ HURT !!     " ,0C
	.TEXT " GETTING DATA   " ,0D
	.TEXT "                " ,0E

LCDSET	MOV DPTR,#$C000	; LCD 2 Zeilen, Cursor, etc
	MOV A,#$0F	
	MOVX @DPTR,A
	LCALL VERZ
	MOV A,#$01
	MOVX @DPTR,A
	LCALL VERZ
	MOV A,#$07
	MOVX @DPTR,A
	LCALL VERZ
	MOV A,#$38
	MOVX @DPTR,A
	INC DPTR	; DPTR auf LCD-Datenport
	LCALL VERZ
	RET

WAITL	MOV HDPH,DPH	; DPTR retten    ---AUF LCD READY WARTEN
	MOV HDPL,DPL
	PUSH ACC
	MOV DPTR,#$C001 
	MOVX @DPTR,A	; Zeichen ausgeben
	MOV DPTR,#$C000 ; Kommandoregister
WAITL1	MOVX A,@DPTR 	; laden
	RLC A
	NOP		; BUSY-Flag in Carry
	JC WAITL1	; Busy
	MOV DPH,HDPH	; DPTR restore
	MOV DPL,HDPL
	POP ACC
	RET		; not Busy

VERZ	MOV B,#$FF	; Verzoegerung
VERZ1	NOP
	NOP
	NOP
	DJNZ B,VERZ1
	RET
	.LIST
