	.NOLIST
	;-------- Setup-Menu ------------
	; Ansprung mit LCALL
	; Aendert RAM-Variablen
	; Benutzte Stack-Tiefe 7 Byte
	;
MENU	MOV DPTR,#$8000	; LED ON-Line aus
	MOV A,#$00
	MOVX @DPTR,A	; LED-Muster ausgeben
	MOV A,#$05	; Headline SETUP PLOTTER
	LCALL HEADL
	MOV A,#$05	; Baseline  ENTER?
	LCALL BASEL	
MENUTA	MOVX A,@DPTR	; auf TASTE loslassen warten
	CJNE A,#$FF,MENUTA
	LCALL VERZ
MENUSCH	MOVX A,@DPTR	; Tasten holen
	CJNE A,#$FF,MENUSC1
	SJMP MENUSCH
MENUSC1	CJNE A,#$FB,MENU1I ; ENTER ?
	SJMP MENU1ST	; Setup starten
MENU1I	CJNE A,#$BF,MENUSCH	; ON-LINE ?
	RET
MENU1ST	LCALL VERZ
	MOVX A,@DPTR	; auf Taste loslassen warten
	CJNE A,#$FF,MENU1ST
	MOV A,#$20	; LED MENU an
	MOVX @DPTR,A	; LED-Muster ausgeben
	CLR A		; Headline 0 SET OFFSET ausgeben
	LCALL HEADL
	CLR A		; Baseline 0 ENTER = END ausgeben
	LCALL BASEL	
MENU1	MOVX A,@DPTR	; Tasten holen
	JB ACC.0,MENUA
	LCALL YM	; DOWN
	MOVX A,@DPTR
MENUA	JB ACC.1,MENUB
	LCALL XM	; LEFT
	MOVX A,@DPTR
MENUB   JB ACC.3,MENUC
	LCALL YP	; UP
	MOVX A,@DPTR
MENUC	JB ACC.4,MENUD
	LCALL XP	; RIGHT
MENUD	MOV R0,#$02	; Schrittverzoegerung
MENUD1	MOV TH0,#$06
	MOV TL0,#$00
	SETB TCON.4
	JNB TCON.5,$
	CLR TCON.4
	CLR TCON.5
	DJNZ R0,MENUD1
	MOVX A,@DPTR
	JB ACC.2,MENUE	
	CLR A		; ENTER
	MOV XPOSH,A	; OFFSET-Nullpunkt setzen
	MOV XPOSL,A
	MOV YPOSH,A
	MOV YPOSL,A
	SJMP MENU2	; weiter
MENUE	JB ACC.6,MENUF
	MOV A,#$10	; LED On-Line
	MOVX @DPTR,A
	RET		; ON-LINE
MENUF	SJMP MENU1	; weiter OFFSET
MENU2	MOV A,#$01	; Headline BAUD RATE
	LCALL HEADL
	MOV A,#$01	; Baseline  1200....
	LCALL BASEL	
MENU21	MOV A,BDRAT	; Cursor auf aktuelle Rate
	CJNE A,#$E8,MENU2A ; 1200?
	MOV A,#$C1	; 2.Spalte
	LCALL SETCURS	; Cursor setzen
	SJMP MENU2D	; weiter
MENU2A	CJNE A,#$F4,MENU2B ; 2400?
	MOV A,#$C6	; 7.Spalte
	LCALL SETCURS	; Cursor setzen
	SJMP MENU2D	; weiter
MENU2B	CJNE A,#$FA,MENU2C ; 4800?
	MOV A,#$CB	; 12.Spalte
	LCALL SETCURS	; Cursor setzen
	SJMP MENU2D
MENU2C	LJMP ERROR	; RAM-Fehler!
MENU2D	MOVX A,@DPTR	; Tasten holen
	CJNE A,#$FF,MENU2D ; warten, bis keine Taste gedruekt
	LCALL VERZ	; entprellen
MENU2DH	MOVX A,@DPTR	; Taste holen
	CJNE A,#$FF,MENU2DT ; Taste gedrueckt
	SJMP MENU2DH
MENU2DT	CJNE A,#$FD,MENU2F ; LEFT
	MOV A,BDRAT	; aktuelle Baudrate
	CJNE A,#$E8,MENU2DA ; 1200?
	MOV BDRAT,#$FA	; neu 4800
	SJMP MENU21	; weiter
MENU2DA	CJNE A,#$F4,MENU2DB ; 2400?
	MOV BDRAT,#$E8	; neu 1200
	SJMP MENU21
MENU2DB MOV BDRAT,#$F4	; neu 2400
	SJMP MENU21
MENU2F	CJNE A,#$EF,MENU2G ; RIGHT
	MOV A,BDRAT
	CJNE A,#$E8,MENU2FA ; 1200?
	MOV BDRAT,#$F4	; neu 2400
	SJMP MENU21
MENU2FA	CJNE A,#$F4,MENU2FB ; 2400?
	MOV BDRAT,#$FA	; neu 4800
	SJMP MENU21
MENU2FB	MOV BDRAT,#$E8	; neu 1200
	SJMP MENU21
MENU2G  CJNE A,#$FB,MENU21 ; ENTER
MENU3	MOV A,#$02	; Headline SCALE FACTOR
	LCALL HEADL
	MOV A,#$02	; Baseline 2 1:1,...ausgeben
	LCALL BASEL	
MENU31	MOV A,SCALEF	; Cursor auf aktuellen Faktor
	CJNE A,#$01,MENU3A ; 2:1?
	MOV A,#$C1	; 2.Spalte
	LCALL SETCURS	; Cursor setzen
	SJMP MENU3D	; weiter
MENU3A	CJNE A,#$02,MENU3B ; 1:1?
	MOV A,#$C6	; 7.Spalte
	LCALL SETCURS	; Cursor setzen
	SJMP MENU3D	; weiter
MENU3B	CJNE A,#$04,MENU3C ; 1:2?
	MOV A,#$CB	; 12.Spalte
	LCALL SETCURS	; Cursor setzen
	SJMP MENU3D
MENU3C	LJMP ERROR	; RAM-Fehler!
MENU3D	MOVX A,@DPTR	; Tasten holen
	CJNE A,#$FF,MENU3D	; warten, bis keine Taste gedruekt
	LCALL VERZ 	; entprellen
MENU3DH	MOVX A,@DPTR	; Taste holen
	CJNE A,#$FF,MENU3DT
	SJMP MENU3DH
MENU3DT	CJNE A,#$FD,MENU3F ; LEFT
	MOV A,SCALEF	; aktueller Faktor
	CJNE A,#$01,MENU3DA ; 2:1?
	MOV SCALEF,#$04	; neu 1:2
	SJMP MENU31	; weiter
MENU3DA	CJNE A,#$02,MENU3DB ; 1:1?
	MOV SCALEF,#$01	; neu 2:1
	SJMP MENU31
MENU3DB	MOV SCALEF,#$02	; neu 1:1
	SJMP MENU31
MENU3F	CJNE A,#$EF,MENU3G ; RIGHT
	MOV A,SCALEF
	CJNE A,#$01,MENU3FA ; 2:1?
	MOV SCALEF,#$02	; neu 1:1
	SJMP MENU31
MENU3FA	CJNE A,#$02,MENU3FB ; 1:1?
	MOV SCALEF,#$04	; neu 1:2
	SJMP MENU31
MENU3FB	MOV SCALEF,#$01	; neu 2:1
	SJMP MENU31
MENU3G	CJNE A,#$FB,MENU3 ; ENTER
MENU4	MOV A,#$03	; Headline PLOT SPEED
	LCALL HEADL
	MOV A,#$03	; Baseline 2 SLOW,...ausgeben
	LCALL BASEL	
MENU41	MOV A,PSSPD	; Cursor auf aktuelle Geschw.
	CJNE A,#$50,MENU4A ; SLOW?
	MOV A,#$C1	; 2.Spalte
	LCALL SETCURS	; Cursor setzen
	SJMP MENU4D	; weiter
MENU4A	CJNE A,#$DC,MENU4B ; NORM?
	MOV A,#$C6	; 7.Spalte
	LCALL SETCURS
	SJMP MENU4D	; weiter
MENU4B	CJNE A,#$EF,MENU4C ; FAST?
	MOV A,#$CB	; 12.Spalte
	LCALL SETCURS	; Cursor setzen
	SJMP MENU4D
MENU4C	LJMP ERROR	; RAM-Fehler!
MENU4D	MOVX A,@DPTR	; Tasten holen
	CJNE A,#$FF,MENU4D ; warten, bis keine Taste gedruekt
	LCALL VERZ	; entprellen
MENU4DH	MOVX A,@DPTR	; Taste holen
	CJNE A,#$FF,MENU4DT
	SJMP MENU4DH
MENU4DT	CJNE A,#$FD,MENU4F ; LEFT
	MOV A,PSSPD	; aktueller Faktor
	CJNE A,#$50,MENU4DA ; SLOW?
	MOV PSSPD,#$EF	; neu FAST
	SJMP MENU41	; weiter
MENU4DA	CJNE A,#$DC,MENU4DB ; NORM?
	MOV PSSPD,#$50	; neu SLOW
	SJMP MENU41
MENU4DB	MOV PSSPD,#$DC	; neu NORM
	SJMP MENU41
MENU4F	CJNE A,#$EF,MENU4G ; RIGHT
	MOV A,PSSPD
	CJNE A,#$50,MENU4FA ; SLOW?
	MOV PSSPD,#$DC	; neu NORM
	SJMP MENU41
MENU4FA	CJNE A,#$DC,MENU3FB ; NORM?
	MOV PSSPD,#$EF	; neu FAST
	SJMP MENU41
MENU4FB	MOV SCALEF,#$50	; neu SLOW
	SJMP MENU41
MENU4G	CJNE A,#$FB,MENU4 ; ENTER
	LJMP MENU	; von vorne anfangen
MENU5	LJMP MENU	; von vorne anfangen
	
SETCURS	PUSH DPH	; DPTR retten   ---LCD-Steuerbefehl in ACC ausgeben
	PUSH DPL
	MOV DPTR,#$C000	; Kommandoregister
	MOVX @DPTR,A	; Cursor-steuerbefehl
	LCALL VERZ
	POP DPL		; DPTR restore
	POP DPH
	RET
	
BASEL	MOV R2,A 	; BASELINE AUSGEBEN
	PUSH DPH
	PUSH DPL
	MOV DPTR,#$C000	; Kommandoregister
	MOV A,#$A8	; 2.Zeile
	MOVX @DPTR,A
	LCALL VERZ
	MOV A,R2
	MOV R0,#$00	; Zaehler
	MOV B,#$10	; Laenge der Eintraege
	MUL AB
	ADD  A,#$10	; Offset zur Texttabelle
	MOV B,A
BASEL1	MOVC A,@A+PC	; Zeichen holen
	LCALL WAITL
	INC B
	INC R0
	MOV A,B
	CJNE R0,#$10,BASEL1
	POP DPL
	POP DPH
	RET
	.TEXT " ENTER=SET OFFS." ;00
	.TEXT " 1200 2400 4800 " ;01
	.TEXT " 2:1  1:1  1:2  " ;02
	.TEXT " SLOW NORM FAST " ;03
	.TEXT " ACTIVE INACTIVE" ;04
	.TEXT " ENTER?         " ;05
	

HEADL	MOV R2,A 	; HEADLINE AUSGEBEN
	PUSH DPH
	PUSH DPL
	MOV DPTR,#$C000	; Kommandoregister
	MOV A,#$80	; 1.Zeile
	MOVX @DPTR,A
	LCALL VERZ
	MOV A,R2
	MOV R0,#$00	; Zaehler
	MOV B,#$10	; LAENGE der Eintraege
	MUL AB
	ADD  A,#$10	; Offset zur Tabelle
	MOV B,A
HEADL1	MOVC A,@A+PC	; Zeichen holen
	LCALL WAITL
	INC B
	INC R0
	MOV A,B
	CJNE R0,#$10,HEADL1
	POP DPL
	POP DPH
	RET
	.TEXT " SET OFFSET     " ;00
	.TEXT " BAUD RATE      " ;01
	.TEXT " SCALE FACTOR   " ;02
	.TEXT " PLOT SPEED     " ;03
	.TEXT " SWAP AXES      " ;04
	.TEXT " SETUP PLOTTER  " ;05
	.TEXT " SETRONICS P1   " ;06



